﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module ---------------------------------------------------------------------
'
' Codded by Steve De George SR,  may-2012
' (c)All of humankind
'
'---------------------------------------------------------------------------------
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim straight,flushMe,msg,onePairVal,threeOfAKind,twoPairVal As String
	Dim card_val(5) As String
	Dim card_suit(5) As String
	
	'--- what part of the array has scoreing cards
	Dim arrScoreCards(4) As Int
	
	Dim str1Pair As String = "One pair"
	Dim str2Pair As String = "Two pair"
	Dim strFlush As String = "Flush"
	Dim str3ofAKind As String = "Three of a kind"
	Dim strFullHouse As String = "Full house"
	Dim strStraight As String = "Straight"
	Dim str4ofAKind As String = "Four of a kind"
	Dim strStraightFlush As String = "Straight flush"
	Dim strRoyalFlush As String = "Royal flush"
	
End Sub

Private Sub Val(s As Object) As Int
	Dim n As Int = s
	Return n
End Sub

Public Sub Check4Score(cards() As String)

	'--- if this has a value then you have a scoring hand
	msg = "" 
	
	'--- shows what cards in the array where used for the score
	'--- if Array is (1,0,0,0,1) then the 1st and last card where scoring cards
	arrScoreCards = Array As Int(0,0,0,0,0) 
	
	flushMe = ""
	straight = ""
	twoPairVal = ""
	onePairVal = ""
	threeOfAKind = ""	
	
	'--- clean up the cards
	Dim tmp As String, x As Int
	For x = 0 To 4
	
		card_suit(x) = cards(x).SubString2(0,1)
		If cards(x).Length = 2 Then 
			card_val(x) = cards(x).SubString2(1,2)
			tmp = "" '--- change Jacks, queen, king to nums
			Select Case card_val(x)
				Case "j" : tmp = "11"
				Case "q" : tmp = "12"
				Case "k" : tmp = "13"
			End Select
			If tmp <> "" Then card_val(x) = tmp	
		Else
			'--- for the 10 card, 3 digits
			card_val(x) = cards(x).SubString2(1,3)
		End If
		
	Next
	
	CheckStraight
	Check1Pair
	Check2Pair
	Check3ofAKind
	CheckFullHouse '--- you can really exit here if you have a full house
	Check4ofAkind
	CheckFlush	
	CheckStraightFlush
	CheckRoyalFlush
	
End Sub

Private Sub CheckFlush()
	Dim bGood As Boolean = False
	If (card_suit(0) = card_suit(1)) AND (card_suit(1) = card_suit(2)) AND _
			(card_suit(2) = card_suit(3)) AND (card_suit(3) = card_suit(4)) Then
		bGood = True
	End If	
	If bGood Then
		msg = strFlush
		flushMe = "1"
		arrScoreCards = Array As Int(1,1,1,1,1)
	End If
End Sub

Private Sub Check1Pair
	Dim bGood As Boolean = False
	Do While True
		If (card_val(3) = card_val(4)) Then
			bGood = True : onePairVal = card_val(3)
			arrScoreCards = Array As Int(0,0,0,1,1)
			Exit
		End If
		If (card_val(2) = card_val(3)) Then
			bGood = True : onePairVal = card_val(2)
			arrScoreCards = Array As Int(0,0,1,1,0)
			Exit
		End If
		If (card_val(2) = card_val(4)) Then
			bGood = True : onePairVal = card_val(2)
			arrScoreCards = Array As Int(0,0,1,0,1)
			Exit
		End If
		If (card_val(1) = card_val(2)) Then
			bGood = True : onePairVal = card_val(1)
			arrScoreCards = Array As Int(0,1,1,0,0)
			Exit
		End If
		If (card_val(1) = card_val(3)) Then
			bGood = True : onePairVal = card_val(1)
			arrScoreCards = Array As Int(0,1,0,1,0)
			Exit
		End If
		If (card_val(1) = card_val(4)) Then
			bGood = True : onePairVal = card_val(1)
			arrScoreCards = Array As Int(0,1,0,0,1)
			Exit
		End If
		If (card_val(0) = card_val(1)) Then
			bGood = True  : onePairVal = card_val(0)
			arrScoreCards = Array As Int(1,1,0,0,0)
			Exit
		End If
		If (card_val(0) = card_val(2)) Then
			bGood = True  : onePairVal = card_val(0)
			arrScoreCards = Array As Int(1,0,1,0,0)
			Exit
		End If
		If (card_val(0) = card_val(3)) Then
			bGood = True  : onePairVal = card_val(0)
			arrScoreCards = Array As Int(1,0,0,1,0)
			Exit
		End If
		If (card_val(0) = card_val(4)) Then
			bGood = True  : onePairVal = card_val(0)
			arrScoreCards = Array As Int(1,0,0,0,1)
			Exit
		End If
		
		Exit
	Loop
	If bGood Then
		msg = str1Pair
	End If
End Sub

Private Sub Check2Pair()
	Dim bGood As Boolean = False
	Dim secondPairVal As String = ""
	
	Dim TMParrScoreCards(4) As Int
	TMParrScoreCards = Array As Int(0,0,0,0,0)
	
	
	If msg <> "" Then
		'--- we already have 1 pair
		'--- now lets check for a second pair
		'--- this works because the 1 pair routine jumps out after the 1st match
		'--- and this routine goe all the way to the end and will find the 2nd match
		Do While True
			If (card_val(3) = card_val(4)) Then
				bGood = True : secondPairVal = card_val(3)
				TMParrScoreCards = Array As Int(0,0,0,1,1)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(2) = card_val(3)) Then
				bGood = True : secondPairVal = card_val(2)
				TMParrScoreCards = Array As Int(0,0,1,1,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(2) = card_val(4)) Then
				bGood = True : secondPairVal = card_val(2)
				TMParrScoreCards = Array As Int(0,0,1,0,1)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(1) = card_val(2))  Then
				bGood = True : secondPairVal = card_val(1)
				TMParrScoreCards = Array As Int(0,1,1,0,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(1) = card_val(3)) Then
				bGood = True : secondPairVal = card_val(1)
				TMParrScoreCards = Array As Int(0,1,0,1,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(1) = card_val(4)) Then
				bGood = True : secondPairVal = card_val(1)
				TMParrScoreCards = Array As Int(0,1,0,0,1)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(0) = card_val(1)) Then
				bGood = True  : secondPairVal = card_val(0)
				TMParrScoreCards = Array As Int(1,1,0,0,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(0) = card_val(2))  Then
				bGood = True  : secondPairVal = card_val(0)
				TMParrScoreCards = Array As Int(1,0,1,0,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(0) = card_val(3))  Then
				bGood = True  : secondPairVal = card_val(0)
				TMParrScoreCards = Array As Int(1,0,0,1,0)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			If (card_val(0) = card_val(4))  Then
				bGood = True  : secondPairVal = card_val(0)
				TMParrScoreCards = Array As Int(1,0,0,0,1)
				If Is2PairDifferent(secondPairVal) Then Exit
			End If
			Exit
		Loop
	Else
		Return
	End If
	'--- see if we have 2 diff pair
	If bGood Then
		If Is2PairDifferent(secondPairVal) Then
			bGood = True
			Dim x As Int
			For x = 0 To 4
				If TMParrScoreCards(x) = 1 Then
					arrScoreCards(x) = 1
				End If
			Next
		Else
			Return
		End If
	End If
	
	If bGood Then
		twoPairVal = secondPairVal '--- full house uses this
		msg = str2Pair
	End If
End Sub
Private Sub Is2PairDifferent(secondPairVal As String) As Boolean
	If secondPairVal <> onePairVal Then Return True
	Return False
End Sub

Private Sub Check3ofAKind
	Dim bGood As Boolean = False	
	
	Do While True
	
		If (card_val(2) = card_val(3)) AND (card_val(2) = card_val(4))  Then
			arrScoreCards = Array As Int(0,0,1,1,1)
			threeOfAKind = card_val(2)
			bGood = True : Exit '--- D
		End If
		
		If (card_val(1) = card_val(3)) AND (card_val(1) = card_val(4))  Then
			arrScoreCards = Array As Int(0,1,0,1,1)
			threeOfAKind = card_val(1)
			bGood = True : Exit '--- E
		End If
		
		If (card_val(0) = card_val(3)) AND (card_val(0) = card_val(4)) Then
			arrScoreCards = Array As Int(1,0,0,1,1)
			threeOfAKind = card_val(0)
			bGood = True : Exit '--- F
		End If
		
		If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(2)) Then
			arrScoreCards = Array As Int(1,1,1,0,0)
			threeOfAKind = card_val(1)
			bGood = True : Exit   '--- C
		End If
		
		If (card_val(0) = card_val(2)) AND (card_val(0) = card_val(3)) Then  '--- B
			arrScoreCards = Array As Int(1,0,1,1,0)
			threeOfAKind = card_val(0)
			bGood = True : Exit
		End If
		If (card_val(0) = card_val(2)) AND (card_val(0) = card_val(4)) Then  '--- B
			arrScoreCards = Array As Int(1,0,1,0,1)
			threeOfAKind = card_val(0)
			bGood = True : Exit
		End If

		
		If (card_val(1) = card_val(2)) AND (card_val(1) = card_val(3)) Then  '--- J
			arrScoreCards = Array As Int(0,1,1,1,0)
			threeOfAKind = card_val(1)
			bGood = True : Exit
		End If
		
		If (card_val(1) = card_val(2)) AND (card_val(1) = card_val(4))  Then
			arrScoreCards = Array As Int(0,1,1,0,1)
			threeOfAKind = card_val(1)
			bGood = True : Exit 
		End If
		
		If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(4))  Then
			arrScoreCards = Array As Int(1,1,0,0,1)
			threeOfAKind = card_val(0)
			bGood = True : Exit 
		End If
		
		If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(3))  Then
			arrScoreCards = Array As Int(1,1,0,1,0)
			threeOfAKind = card_val(0)
			bGood = True : Exit 
		End If
		
		Exit
		
	Loop
	If bGood Then
		msg = str3ofAKind
	End If
End Sub


Private Sub CheckFullHouse
	Dim bGood As Boolean = False
	
	Do While True
		If (threeOfAKind.Length > 0) Then
			'--- we have 3 of a kind
			If onePairVal <> threeOfAKind Then
				bGood = True : Exit
			End If
			If twoPairVal.Length <> 0 Then
				If twoPairVal <> threeOfAKind Then
					bGood = True : Exit
				End If
			End If
		End If
		Exit
	Loop
	
	If bGood Then
		msg = strFullHouse
		arrScoreCards = Array As Int(1,1,1,1,1)
	End If
End Sub

Private Sub Check4ofAkind
	Dim bGood As Boolean = False
	
	If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(2)) AND _
									   (card_val(0) = card_val(3)) Then
		arrScoreCards = Array As Int(1,1,1,1,0)
		bGood = True
	End If
	
	If (card_val(1) = card_val(2)) AND (card_val(1) = card_val(3)) AND _
									   (card_val(1) = card_val(4)) Then
		arrScoreCards = Array As Int(0,1,1,1,1)
		bGood = True
	End If
	
	If (card_val(0) = card_val(2)) AND (card_val(0) = card_val(3)) AND _
									   (card_val(0) = card_val(4)) Then
		arrScoreCards = Array As Int(1,0,1,1,1)
		bGood = True
	End If
	
	If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(3)) AND _
									   (card_val(0) = card_val(4)) Then
		arrScoreCards = Array As Int(1,1,0,1,1)
		bGood = True
	End If
	
	If (card_val(0) = card_val(1)) AND (card_val(0) = card_val(2)) AND _
									   (card_val(0) = card_val(4)) Then
		arrScoreCards = Array As Int(1,1,1,0,1)
		bGood = True
	End If
	
	If bGood Then
		msg = str4ofAKind
	End If
End Sub

Private Sub CheckStraight()
	Dim bGood As Boolean = False	
	Dim x As Int

	'--- do we have an ACE [BUG fix for 0.92]
	For x = 0 To 4
		If card_val(x) = "1" Then
			card_val(x) = "14" 
			Exit 
		End If
	Next
	
	Dim l As List : l.Initialize
	Dim addMe As Int
	For x = 0 To 4
		addMe = card_val(x)
		l.add(addMe) '--- convert to num
	Next
	l.Sort(True)
	
	If Val(l.Get(0)) = Val((l.Get(1) - 1)) Then
		If Val(l.Get(1)) = Val((l.Get(2) - 1)) Then
			If Val(l.Get(2)) = Val((l.Get(3) - 1)) Then
				If Val(l.Get(3)) = Val((l.Get(4) - 1)) Then
					bGood = True
				End If
			End If
		End If
	End If
	
	If bGood Then
		msg = strStraight
		straight = "1"
		arrScoreCards = Array As Int(1,1,1,1,1)
	End If 
End Sub


Private Sub CheckStraightFlush
	Dim bGood As Boolean = False
	
	If flushMe.Length <> 0 Then
		If straight.Length <> 0 Then
			bGood = True
		End If
	End If
	
	If bGood Then
		msg = strStraightFlush
		arrScoreCards = Array As Int(1,1,1,1,1)
	End If
End Sub


Private Sub CheckRoyalFlush
	Dim bGood As Boolean = False
	Dim x As Int 
	
	Do While True
		If flushMe.Length <> 0 Then
			'--- need to do the sort like a straight
			'---  10,jack,queen,king,ace
			'--- but convert the ACE from #1 to a #14
			
			'--- do we even have an ACE?
			For x = 0 To 4
				If card_val(x) = "1" Then
					bGood = True
					card_val(x) = "14" 
					Exit 
				End If
			Next
			
			If bGood = False Then
				Return '--- no ace
			End If
			bGood = False
			
			'--- now do a regular 'look for straight' 	
			Dim l As List : l.Initialize
			Dim addMe As Int
			For x = 0 To 4
				addMe = card_val(x)
				l.add(addMe) '--- convert to num
			Next
			l.Sort(True)
			
				
			If Val(l.Get(0)) = Val((l.Get(1) - 1)) Then
				If Val(l.Get(1)) = Val((l.Get(2) - 1)) Then
					If Val(l.Get(2)) = Val((l.Get(3) - 1)) Then
						If Val(l.Get(3)) = Val((l.Get(4) - 1)) Then
							bGood = True
						End If
					End If
				End If
			End If
			
		
		
		End If
		Exit
		
	Loop	
	If bGood Then
		msg =  strRoyalFlush
		arrScoreCards = Array As Int(1,1,1,1,1)
	End If
End Sub










